% === filter_1b.m ===
% ===       ===
%
% ===    ===
a0=0.5;                                  %   
ak=[0.3183 0 -0.1061];                   %   c 1  3
fd=100;                                  %  
dt=1/fd;                                 %  () 
N=3;                                     %   
df=0.02*fd;                              %   
% ===   ===
sum = zeros(1,100);                      %    
f = zeros(1,100);                        %    
% ===    ===
tic
for k=1:N                            %    
    for n=1:100                      %   
       f(n) = n*df-fd/2;                  %   
       sum(n)=sum(n)+ak(k)*cos(2*pi*f(n)*k*dt); %  
    end
end
toc
H=a0+2*sum;                              %   
figure;                                  %   
plot(f,H,'r')                                %  
grid on                                  %   
xlabel(', ', 'FontSize', 14); ylabel('', 'FontSize', 14);
title(' -   6- ', 'FontSize', 14);
hold on
% ===     ===
ak1 = fir1(2*N,0.5,boxcar(2*N+1),'noscale');
[H1,f1] = freqz(ak1,1,25,100);
stem(f1,abs(H1));