% === filtering_fir.m ===
% ===    x(n) ===
%
% ===   x(n) ===
x = [1 2 3 -3 -2 -1 0 1 2 3 -3 -2 -1 0 1 2 3 -3 -2 -1];
% ===   ===
ak=[-0.1061 0 0.3183 0.5 0.3183 0 -0.1061];
%
% ===       x(n) ===
lak = length(ak);
nz = lak-1;
zrs = zeros(1,nz);
xz = [zrs x zrs];
%
% ===  x(n)   ===
nfrm = length(xz)-lak+1;
xfrm = zeros(lak,nfrm);  %  
for k = 1:nfrm
    xfrm(:,k) = xz(k:k+lak-1);
end
%
% ===  ===
y = ak*xfrm;
%
% ===    ===
y1 = filter(ak,1,x);

% ===   ===
tx = 0:(length(x)-1);
ty = 0:(length(y)-1);
ty1 = 0:(length(y1)-1);
figure; plot(tx,x,'-o');
xlabel(' ');ylabel('');title(' ');
figure; plot(ty,y);
xlabel(' ');ylabel('');title(' ');
hold on;
stem(ty1,y1,'r');
legend(' ',' Matlab');

% ===     ===
figure % new figure
ax1 = subplot(2,1,1); % top subplot
ax2 = subplot(2,1,2); % bottom subplot

plot(ax1,tx,x,'-o')
xlabel(ax1,' '); ylabel(ax1,'');
title(ax1,' ');

plot(ax2,ty,y,'-x'); hold on; stem(ax2, ty1, y1, 'r');
xlabel(ax2,' '); ylabel(ax2,'');
title(ax2,' ');
legend(ax2, ' ',' Matlab');