% === freq_har.m ===  -  ===
a0=0.5;                                  %   
ak=[0.3183 0 -0.1061];          %   c 1  3
fd=100;                                  %  
dt=1/fd;                                 %  () 
N=3;                                      %   
df=0.02*fd;                            %   
f=-0.5*fd:df:1.5*fd;               %  
k = 1:N;
% ===   ===
cosm = cos(2*pi*k'*f*dt);        %    
sum = ak*cosm;
H=a0+2*sum;                      %  -
figure;
plot(f,H,'-r')                               %  
grid on                                 %  
hold on
% ===     ===
ak1 = fir1(2*N,0.5,boxcar(2*N+1),'noscale');
[H1,f1] = freqz(ak1,1,25,100);
stem(f1,abs(H1));